// AsyncRead.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"

#include <Windows.h>

VOID CALLBACK FileRead(
  DWORD dwErrorCode,
  DWORD dwNumberOfBytesTransfered,
  LPOVERLAPPED lpOverlapped
)
{
	printf("Done...\n");
}


int _tmain(int argc, _TCHAR* argv[])
{
	HANDLE file = CreateFile(TEXT("test.txt"), GENERIC_READ, 0, NULL, OPEN_EXISTING, FILE_FLAG_OVERLAPPED | FILE_ATTRIBUTE_NORMAL, NULL);
	if (file == INVALID_HANDLE_VALUE)
		return 1;

	DWORD size = GetFileSize(file, NULL);
	char* buffer = (char*)LocalAlloc(LPTR, size + 1);

	OVERLAPPED token;
	ZeroMemory(&token, sizeof(OVERLAPPED));
	token.hEvent =  CreateEvent(NULL, true, false, NULL);

	if (!ReadFileEx(file, buffer, size, &token, &FileRead))
		return 2;

	WaitForSingleObjectEx(token.hEvent, INFINITE, true);
	
	DWORD read;
	GetOverlappedResult(file, &token, &read, TRUE);

	if (read != size) return 3;

	printf("Read:\n%s", buffer);

	CloseHandle(file);
	CloseHandle(token.hEvent);
 
	return 0;
}

